/*

Copyright (c) 1989-1993  Microsoft Corporation

Module Name:

    bsddef.h

Abstract:

    Type definitions for the basic types.

Author:

    Mark Lucovsky (markl)   02-Feb-1989

Revision History:

--*/

#ifndef _BSDDEF_
#define _BSDDEF_

/*#include <ctype.h>  // winnt ntndis */

#ifndef IN
#define IN
#endif

#ifndef OUT
#define OUT
#endif

typedef void *PVOID;    /* winnt */

/* */
/* Basics */
/* */

#ifndef VOID
#define VOID void
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
#endif

/* */
/* Pointer to Basics */
/* */

typedef CHAR *PCHAR;  /* winnt */
typedef SHORT *PSHORT;  /* winnt */
typedef LONG *PLONG;    /* winnt */

/* */
/* Unsigned Basics */
/* */

/* Tell windef.h that some types are already defined. */
#define BASETYPES

typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;

/* */
/* Pointer to Unsigned Basics */
/* */

typedef UCHAR *PUCHAR;
typedef USHORT *PUSHORT;
typedef ULONG *PULONG;

/* */
/* Signed characters */
/* */

typedef signed char SCHAR;
typedef SCHAR *PSCHAR;

#ifndef NO_STRICT
#ifndef STRICT
#define STRICT 1
#endif
#endif

/* */
/* Cardinal Data Types [0 - 2**N-2) */
/* */

typedef char CCHAR;          /* winnt */
typedef short CSHORT;
typedef ULONG CLONG;

typedef CCHAR *PCCHAR;
typedef CSHORT *PCSHORT;
typedef CLONG *PCLONG;

/* */
/* */
/* */
typedef int BSDSTATUS;

#define BSD_SUCCESS(Status) ((BSDSTATUS)(Status) == 0)

#define NT_ERROR(Status) ((ULONG)(Status) != 0)

/* */
/* Boolean */
/* */

typedef UCHAR BOOLEAN;           /* winnt */
typedef BOOLEAN *PBOOLEAN;       /* winnt */

/* */
/*  Doubly linked list structure.  Can be used as either a list head, or */
/*  as link words. */
/* */

typedef struct _LIST_ENTRY {
   struct _LIST_ENTRY * volatile Flink;
   struct _LIST_ENTRY * volatile Blink;
} LIST_ENTRY, *PLIST_ENTRY;

/* */
/* Constants */
/* */

#define FALSE   0
#define TRUE    1

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif /* NULL */

/* */
/* Calculate the byte offset of a field in a structure of type type. */
/* */

#define FIELD_OFFSET(type, field)    ((LONG)&(((type *)0)->field))


/* */
/* Calculate the address of the base of the structure given its type, and an */
/* address of a field within the structure. */
/* */

#define CONTAINING_RECORD(address, type, field) ((type *)( \
                                                  (PCHAR)(address) - \
                                                  (PCHAR)(&((type *)0)->field)))

#endif /* _BSDDEF_ */
