/****************************************************************************
 * The Command part for DES instruction
 * This format is HARDWARE-DEFINED
 */
typedef struct _DES_COMMAND
{
    BASE_COMMAND    base;
    CRYP_COMMAND    cryp;
#ifdef TRIPLE_DES
    unsigned char   EncKey  [ 24];
#else
    unsigned char   EncKey  [ 8];
#endif
    unsigned char   EncIV   [ 8];

} DES_COMMAND, *PDES_COMMAND;

/****************************************************************************
 * The Result part for DES instruction
 * This format is HARDWARE-DEFINED
 */
typedef struct _DES_RESULT
{
    BASE_RESULT     base;
    CRYP_RESULT     cryp;

} DES_RESULT, *PDES_RESULT;

typedef struct _RC4_COMMAND {
    BASE_COMMAND    base;
    CRYP_RESULT	    cryp;
    unsigned char   EncKey [ 260];
} RC4_COMMAND, *PRC4_COMMAND;


