/*++

Copyright (c) 1997-1998  Microsoft Corporation

Module Name:

    debug.h

Abstract:

    General header file for debug print routine.  Include this header with
    all files using the custom DebugPrint() routine.

Author:

    Steve Dziok (SteveDz)

Environment:

    Kernel mode

Revision History:


--*/

#ifndef __DEBUG_H__
#define __DEBUG_H__

#ifdef DBG

extern ULONG    DebugPrintLevel;
extern UCHAR    DebugBuffer[];

#define DebugPrint(_x_)     DebugPrintRoutine _x_

#else

#define DebugPrint(_x_)

#endif

VOID
DebugPrintRoutine (
    ULONG PrintLevel,
    char const *DebugMessage,
    ...
    );

#endif  /* __DEBUG_H__ */
