/**********************************************************************

    Module: driver.h

        Product: kernel mode driver for "PowerCrypt" encryption
        acceleration board based on Hi/fn 7751 chip
        by Ashley Laurent, Inc.

    ---------------------------------------------------------------

    Copyright:

        Ashley Laurent, Inc., 1999
        All Rights Reserved.

    ---------------------------------------------------------------

    Functional Description:

        Defines the structure of the driver's static global data area
        containing single-instanced global objects. They are initialized at
        the driver start from DriverEntry()
         The main file for the NT driver. Contains the usual stuff NT requires
        any driver to have - DriverEntry and necessary dispatch routines.

    ---------------------------------------------------------------

    Environment:

        NT kernel mode

    ---------------------------------------------------------------

    Author:

        Stan Shkolnyy

    ---------------------------------------------------------------

    Revision history:

        *   05-Mar-99   initial revision

**********************************************************************/

#ifndef __DRIVER_H__
#define __DRIVER_H__

/****************************************************************************
 * Miscelanious constants
 */

#define PWRCRYPT_WORK_DEVICE_UNICODE_NAME_X   L"\\Device\\PwrCryptWorkX"

/****************************************************************************
 */
NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    );

NTSTATUS
PwrCryptCreate(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS
PwrCryptClose(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS
PwrCryptIoctl(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

VOID
PwrCryptUnload(
    IN PDRIVER_OBJECT DriverObject
    );

NTSTATUS
MyCloneUnicodeString(
    IN OUT PUNICODE_STRING  pusDstPath,
    IN     PUNICODE_STRING  pusSrcPath,
    IN     USHORT           nSizeDelta
    );

void ReplaceOrderNum(
    PUNICODE_STRING pusStringX,
    USHORT nOrderNum
    );

#endif
