#ifndef __WATCH_H__
#define __WATCH_H__

#define WATCH_SIGN      0x0f0f0f0f
#define WATCH_ENTRIES   8

typedef struct _MEM_DESC
{
    PUCHAR  pMem;
    ULONG   nSize;
    ULONG   nCS;
    ULONG   Pad;

} MEM_DESC, *PMEM_DESC;

typedef struct _WATCH
{
    ULONG       Type;
    struct _WATCH *pThis;

    BOOLEAN     bRefresh;

    MEM_DESC    md[ WATCH_ENTRIES];

} WATCH, *PWATCH;

/**********************************************************************
 * PUBLIC methods
 */
void
WatchConstructor(
    IN OUT  PWATCH pThis
    );

void
WatchInit(
    IN OUT  PWATCH pThis
    );

void
WatchRecalc(
    IN OUT  PWATCH  pThis
    );

void
WatchDestructor(
    IN PWATCH pThis
    );

void
WatchCheck(
    IN PWATCH pThis
    );

#endif
