#include "slotrack.h"
#include "symlink.h"

/****************************************************************************
 * Driver global data
 */
typedef struct _DRIVER_GLOBALS
{
    SLOTTRACKER         SlotTracker;
    PDEVICE_OBJECT      pDevObj;
    SYMLINK             SymLink;
    PFILE_OBJECT        pPwrCryptFileObj;   // ptr to "open" PwrCrypt link device file obj.

} DRIVER_GLOBALS, *PDRIVER_GLOBALS;

extern  DRIVER_GLOBALS  glob;

/****************************************************************************
 */
NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    );

NTSTATUS
PwrCryptCreate(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS
PwrCryptClose(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS
PwrCryptIoctl(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

VOID
PwrCryptUnload(
    IN PDRIVER_OBJECT DriverObject
    );

void
CalculateCompletionRoutine(
    ULONG   nComplRtnParm1,
    ULONG   nComplRtnParm2
    );
