/**********************************************************************

    Module: calcreqpp.c

        Product: kernel mode driver providing user mode interface
        to the PwrCrypt driver for encryption acceleration board
        based on Hi/fn 7751 chip by Ashley Laurent, Inc.

    ---------------------------------------------------------------

    Copyright:

        Ashley Laurent, Inc., 1999
        All Rights Reserved.

    ---------------------------------------------------------------

    Functional Description:

        Definition of the function that performs preprocessing of the
        user mode calc.request before forwarding it to the core driver
        via KM interface.

    ---------------------------------------------------------------

    Environment:

        NT or BSD kernel and user mode

    ---------------------------------------------------------------

    Author:

        Stan Shkolnyy

    ---------------------------------------------------------------

    Revision history:

        *   16-Mar-99   initial revision

**********************************************************************/

#ifndef __CACLREQPP_H__
#define __CACLREQPP_H__

BOOLEAN
CalcReqCheckAndPrepare
    (
        IN OUT  PIOCTL_PWRCRYPT_CALCULATE_INPUT_OUTPUT  pCalcReq,
        IN      ULONG       nReqLen
    );

#endif /* __CACLREQPP_H__ */
