/**********************************************************************

    Module: briefcomm.h

        Product: kernel mode driver for "PowerCrypt" encryption
        acceleration board based on Hi/fn 7751 chip
        by Ashley Laurent, Inc.

    ---------------------------------------------------------------

    Copyright:

        Ashley Laurent, Inc., 1999
        All Rights Reserved.

    ---------------------------------------------------------------

    Functional Description:

        Defines the "brief" representation of the natural 7751 instruction
        and routines which transfer information (bits) between these two
        kinds of representation.

    ---------------------------------------------------------------

    Environment:

        NT or BSD kernel mode

    ---------------------------------------------------------------

    Author:

        Stan Shkolnyy

    ---------------------------------------------------------------

    Revision history:

        *   19-Mar-99   initial revision

**********************************************************************/

#ifndef __BRIEF_COMM_PRIVATE_H__
#define __BRIEF_COMM_PRIVATE_H__

#include "briefcomm.h"

/****************************************************************************
    Fills bits in pBriefComm, based on the command specified in the pBC.
****************************************************************************/
void
BriefCommandCreateByFullCommand
    (
        OUT     PBRIEF_COMMAND     pBriefComm,
        IN      PBASE_COMMAND      pBC
    );

void
BriefCommandUpdateFullCommand
    (
        IN      PBRIEF_COMMAND     pBriefComm,
        IN OUT  PBASE_COMMAND      pBC
    );

#endif
