/**********************************************************************

    Module: instrchk.h

        Product: kernel mode driver for "PowerCrypt" encryption
        acceleration board based on Hi/fn 7751 chip
        by Ashley Laurent, Inc.

    ---------------------------------------------------------------

    Copyright:

        Ashley Laurent, Inc., 1999
        All Rights Reserved.

    ---------------------------------------------------------------

    Functional Description:

        Prototypes utility functions for checking 7751 instructions

    ---------------------------------------------------------------

    Environment:

        NT or BSD kernel and user mode

    ---------------------------------------------------------------

    Author:

        Stan Shkolnyy

    ---------------------------------------------------------------

    Revision history:

        *   16-Mar-99   initial revision

**********************************************************************/

#ifndef __INSTRCHK_H__
#define __INSTRCHK_H__

#include <instrset.h>

USHORT
CommandGetSizeByBaseCommand
    (
        PBASE_COMMAND   pBC
    );

void
CommandGetMACKeySizeByFullCommand
    (
        IN  PBASE_COMMAND   pBC,
        OUT PUSHORT         pnKeySize
    );

void
CommandGetEncKeySizeByFullCommand
    (
        IN  PBASE_COMMAND   pBC,
        OUT PUSHORT         pnKeySize,
        OUT PUSHORT         pnIVSize
    );

#endif
