/**********************************************************************

    Module: userbuf.h

        Product: kernel mode driver for "PowerCrypt" encryption
        acceleration board based on Hi/fn 7751 chip
        by Ashley Laurent, Inc.

    ---------------------------------------------------------------

    Copyright:

        Ashley Laurent, Inc., 1999
        All Rights Reserved.

    ---------------------------------------------------------------

    Functional Description:

        Prototypes of functions for locking pageable buffer with MDL
        creation and for unlocking it with MDL desctruction.
        The implementation is O/S specific. 

    ---------------------------------------------------------------

    Environment:

        NT or BSD kernel mode

    ---------------------------------------------------------------

    Author:

        Stan Shkolnyy

    ---------------------------------------------------------------

    Revision history:

        *   15-Feb-99   initial revision

**********************************************************************/

#ifndef __USERBUF_H__
#define __USERBUF_H__

#include "osindependence.h"

PWRCRYPT_STATUS
LockBufferCreateMdl
    (
        IN  PVOID               pBuf,
        IN  ULONG               BufSize,
        IN  BOOLEAN             bChargeQuota,
        IN  PWRCRYPT_PROCESSOR_MODE     AccessMode,
        IN  BOOLEAN             bWriteAccessRequired,
        OUT PMDL                *ppMdl
    );

void
UnlockBufferDelMdl
    (
        IN  PMDL    pMdl
    );

#endif /* __USERBUF_H__ */
